
public class Semaphore {
	private int counter;
	private String name;
	public Semaphore(int c, String n){
		counter = c; name = n;
	}
	public synchronized void acquire(){
		System.out.println(Thread.currentThread().getName()+ " "+name+".acquire()");
		while(counter<=0){
			System.out.println(Thread.currentThread().getName()+ " wait......");
			try {
				wait();
			} catch(InterruptedException e) {  }
		}
		counter--;
	}
	public synchronized void release(){
		counter++;
		System.out.println(Thread.currentThread().getName()+" "+name+".release()");
		notify();
	}
}
