import java.util.Random;

public class Book {
	protected final Random gen = new Random();
	protected final String alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	protected int next = 0;
	protected String content ="";
	public synchronized void write(){
		
		String s = alphabet.substring(next,next+1);
		try {
			Thread.sleep(gen.nextInt(100));
		} catch(InterruptedException e) { };
		next = (next+1) % alphabet.length();
		
		content += s;
		System.out.println(Thread.currentThread().getName()+ " add "+s);
	
	}
	public synchronized String read() {
		return content;
	}
}
